IMPLEMENTATION MODULE RNG;

CONST
  idxMax = 54;

VAR
  h: RECORD
    d: ARRAY [ 0 .. idxMax ] OF Types.TCard;
    i,j: CARDINAL;
  END;


<* PUSH *> <* COVERFLOW - *> <* CHECKRANGE - *>
PROCEDURE SetSeed( v: Types.TCard );
VAR
  x: Types.TLngCard;
  i: Types.TCard;
BEGIN
  x := Types.TLngCard( v );
  FOR i := 0 TO idxMax DO
    x := x * 3141592621 + 17;
    h.d[ i ] := Types.TCard( x DIV 10000H );
  END;
  h.i := idxMax;
  h.j := 23;
END SetSeed;

PROCEDURE Read( rng: Types.TCard ) : Types.TCard;
VAR
  x: Types.TCard;
BEGIN
  IF h.i = 0 THEN h.i := idxMax ELSE DEC( h.i ) END;
  IF h.j = 0 THEN h.j := idxMax ELSE DEC( h.j ) END;
  x := h.d[ h.i ] + h.d[ h.j ];
  h.d[ h.i ] := x;
  IF rng = 0 THEN RETURN x ELSE RETURN ( x MOD rng ) END;
END Read;
<* POP *>

BEGIN
  SetSeed( 12345 );
END RNG.
